import { __decorate, __metadata } from 'tslib';
import { css, LitElement, html, property } from 'lit-element';
import { registerElementSafely } from 'lithiumjs/common';

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/** @type {?} */
const styles = css `
  .dropdown div {
    border: 1px solid #ccc;
    padding: 12px;
  }
`;

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
// @dynamic
class XDropdown extends LitElement {
    constructor() {
        super();
        this.visible = false;
        this.title = 'dropdown';
        this.visible = false;
        this.title = 'dropdown';
    }
    /**
     * @return {?}
     */
    static get styles() { return styles; }
    /**
     * @return {?}
     */
    render() {
        return html `
      <div class="dropdown">
        <button @click="${(/**
         * @return {?}
         */
        () => this.toggle())}" class="btn">${this.title}</button>
        ${this.visible ?
            html `
            <div>
              <slot></slot>
            </div>`
            : ''}
      </div>
    `;
    }
    /**
     * @return {?}
     */
    toggle() {
        this.visible = !this.visible;
        this.dispatchEvent(new CustomEvent('visibleChange', { detail: this.visible }));
    }
}
__decorate([
    property(),
    __metadata("design:type", Object)
], XDropdown.prototype, "visible", void 0);
__decorate([
    property(),
    __metadata("design:type", Object)
], XDropdown.prototype, "title", void 0);
registerElementSafely('x-dropdown', XDropdown);

export { XDropdown };
//# sourceMappingURL=lithiumjs-dropdown.js.map
