import { css, LitElement, html } from 'lit-element';
import { registerElementSafely } from 'lithiumjs/common';

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/** @type {?} */
const styles = css `
  :host {
    --primary-color: #ccc;
  }
  .spinner {
    animation: rotation 1.4s linear infinite;
    stroke: #ccc;
    will-change: transform, animation;
  }
  .spinner--light .spinner {
    stroke: var(--primary-color);
  }
  @keyframes rotation
  {
    0% {
      transform: rotate(0deg);
    }
    100% {
      transform: rotate(270deg);
    }
  }
  .circle {
    stroke-dasharray: 187;
    stroke-dashoffset: 0;
    transform-origin: center;
    animation: turn 1.4s ease-in-out infinite;
  }
  @keyframes turn
  {
    0% {
      stroke-dashoffset: 187;
    }
    50% {
      stroke-dashoffset: 46.75;
      transform: rotate(135deg);
    }
    100% {
      stroke-dashoffset: 187;
      transform: rotate(450deg);
    }
  }
`;

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
// @dynamic
class LithiumLoadingSpinner extends LitElement {
    /**
     * @return {?}
     */
    static get styles() {
        return styles;
    }
    /**
     * @return {?}
     */
    render() {
        return html `
      <div>
        <svg class="spinner" width="65px" height="65px" viewBox="0 0 66 66" xmlns="http://www.w3.org/2000/svg">
          <circle class="circle" fill="none" stroke-width="6" stroke-linecap="round" cx="33" cy="33" r="30"></circle>
        </svg>
      </div>
    `;
    }
}
registerElementSafely('li-loading-spinner', LithiumLoadingSpinner);

export { LithiumLoadingSpinner };
//# sourceMappingURL=lithiumjs-loading-spinner.js.map
