import { css, LitElement, html } from 'lit-element';
import { registerElementSafely } from 'lithiumjs/common';

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/** @type {?} */
const styles = css `
  :host {
    --li-header-background-color: #f3f3f3;
    box-sizing: border-box;
    margin-bottom: 12px;
    background-color: var(--li-header-background-color);
    display: flex;
    width: 100%;
    overflow: hidden;
  }

  :host([sticky]) {
    position: fixed;
    z-index: 100;
  }

  ::slotted(a), ::slotted(button) {
    display: flex;
    align-items: center;
    height: 100%;
    padding: 12px;
  }

  ::slotted([li-nav-bar-right]) {
    margin-left: auto;
  }
`;

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
// @dynamic
class LithiumNavBar extends LitElement {
    /**
     * @return {?}
     */
    static get styles() { return styles; }
    /**
     * @return {?}
     */
    render() {
        return html `
      <slot></slot>
    `;
    }
}
registerElementSafely('li-nav-bar', LithiumNavBar);

export { LithiumNavBar };
//# sourceMappingURL=lithiumjs-nav-bar.js.map
