import { __decorate, __metadata } from 'tslib';
import { css, LitElement, html, property } from 'lit-element';
import { registerElementSafely } from 'lithiumjs/common';

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/** @type {?} */
const styles = css `
  :host {
    --shadow-color: rgba(0, 0, 0, 0.1);
    --off-white: #f5f5f5;
    --primary-color: #2d2d2d;
    --text-color: #ccc;
  }
  .lit-progress-bar {
    width: 100%;
    height: 20px;
    background: var(--off-white);
    border-radius: 2px;
    position: relative;
    overflow: hidden;
    text-align: center;
    -webkit-box-shadow: inset 0 1px 2px var(--shadow-color);
    box-shadow: inset 0 1px 2px var(--shadow-color);
    padding: 2px;
    margin-bottom: 4px;
  }
  .lit-progress-bar__inner {
    width: 100%;
    height: 100%;
    background: var(--primary-color);
    position: absolute;
    top: 0;
    left: -100%;
    text-align: center;
    line-height: 35px;
    font-size: 1em;
    will-change: transform;
    transition: transform 100ms ease-in;
  }
  .lit-progress-bar__value {
    color: var(--text-color);
    z-index: 2;
    position: absolute;
    text-align: center;
    left: 0;
    right: 0;
    top: 0;
  }
`;

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
// @dynamic
class LithiumProgressBar extends LitElement {
    constructor() {
        super(...arguments);
        this.value = 0;
        this.showValue = true;
    }
    /**
     * @return {?}
     */
    static get styles() {
        return styles;
    }
    /**
     * @return {?}
     */
    render() {
        return html `
      <div class="lit-progress-bar">
        <div style="transform: translateX(${this.value}%)"
          class="lit-progress-bar__inner" role="progressbar" aria-valuenow="${this.value}" aria-valuemin="0" aria-valuemax="100"></div>
        ${this.showValue ? html `<div class="lit-progress-bar__value">${this.value}%</div>` : ''}
      </div>
    `;
    }
}
__decorate([
    property({ type: Number }),
    __metadata("design:type", Object)
], LithiumProgressBar.prototype, "value", void 0);
__decorate([
    property({ type: Boolean }),
    __metadata("design:type", Object)
], LithiumProgressBar.prototype, "showValue", void 0);
registerElementSafely('li-progress-bar', LithiumProgressBar);

export { LithiumProgressBar };
//# sourceMappingURL=lithiumjs-progress-bar.js.map
