import { __decorate, __metadata } from 'tslib';
import { css, LitElement, html, property } from 'lit-element';
import { registerElementSafely } from 'lithiumjs/common';

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/** @type {?} */
const styles = css `
  :host {
    --border-color: #ccc;
    --padding: 8px;
  }

  .li-tab__content {
    padding: var(--padding);
    overflow: visible;
    min-height: 225px;
    border-top: 1px solid var(--border-color);
  }

  @media (min-width: 480px) {
    .li-tab__content {
      padding: 18px;
    }
  }
`;

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
// @dynamic
class LithiumTab extends LitElement {
    constructor() {
        super(...arguments);
        this.title = '';
    }
    /**
     * @return {?}
     */
    static get styles() { return styles; }
    /**
     * @return {?}
     */
    render() {
        return html `
      <div class="li-tab__content">
        <slot></slot>
      </div>
    `;
    }
}
__decorate([
    property({ type: String }),
    __metadata("design:type", Object)
], LithiumTab.prototype, "title", void 0);

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/** @type {?} */
const styles$1 = css `
  :host {
    --color-primary: #2d2d2d;
    --border-color: #ccc;
    --tab-background-color: #fff;
    --breakpoint: 480px;
  }

  .li-tabs {
    display: block;
  }

  .li-tabs__nav {
    margin-bottom: 0;
    padding-left: 0;
    list-style: none;
  }

  .li-tabs__nav::before, .li-tabs__nav::after {
    content: ' ';
    display: table;
    clear: both;
  }

  .li-tabs__nav > button {
    position: relative;
    display: block;
    background-color: transparent;
    width: 50%;
    float: left;
    margin-bottom: -1px;
    cursor: pointer;
    padding: 10px 6px;
    line-height: 1.42857143;
    text-decoration: none;
    text-align: center;
    transition: all 0.3s;
    font-weight: 500;
    font-size: 14px;
  }

  .li-tabs__nav > button.active,
  .li-tabs__nav > button.active:hover,
  .li-tabs__nav > button.active:focus {
    cursor: default;
    color: var(--color-primary);
  }

  .li-tabs__nav > button:focus,
  .li-tabs__nav > button:hover {
    color: var(--color-primary);
  }

  .li-tabs__nav > button:nth-child(-n + 3) {
    border-bottom: 1px solid var(--border-color);
  }

  .li-tabs__nav > button:nth-child(even) {
    border-right: 1px solid var(--border-color);
  }

  @media (min-width: 300px) {
    .li-tabs__nav > button {
      margin-right: 2px;
      width: auto;
      text-align: left;
      border: 1px solid transparent;
      border-bottom: 3px solid transparent;
    }

    .li-tabs__nav > button:nth-child(even) {
      border-right: 0;
    }

    .li-tabs__nav > button:nth-child(-n + 3) {
      border-bottom: 3px solid transparent;
    }

    .li-tabs__nav > button.active {
      background-color: var(--tab-background-color);
      border: 1px solid var(--border-color);
      border-bottom: 3px solid transparent;
    }
  }

  @media (min-width: 480px) {
    .li-tabs__nav > button {
      padding: 10px 15px;
    }
  }
`;

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
// @dynamic
class LithiumTabs extends LitElement {
    constructor() {
        super(...arguments);
        this.tabs = [];
        this.index = 0;
    }
    /**
     * @return {?}
     */
    static get styles() { return styles$1; }
    /**
     * @return {?}
     */
    render() {
        return html `
      <div class="li-tabs">
        <div class="li-tabs__nav">
          ${this.tabs.map((/**
         * @param {?} t
         * @param {?} i
         * @return {?}
         */
        (t, i) => html `
            <button className=${this.index === i ? 'active' : ''} @click=${(/**
         * @return {?}
         */
        () => this.tabClick(i))}>${t.title}</button>
          `))}
        </div>
        <slot></slot>
      </div>
    `;
    }
    /**
     * @return {?}
     */
    connectedCallback() {
        super.connectedCallback();
        this.tabs = [].slice.call(this.querySelectorAll('li-tab'));
        this.tabClick(0);
    }
    /**
     * @private
     * @param {?} index
     * @return {?}
     */
    tabClick(index) {
        this.index = index;
        this.showTab();
    }
    /**
     * @private
     * @return {?}
     */
    showTab() {
        this.tabs.forEach((/**
         * @param {?} t
         * @return {?}
         */
        t => t.style.display = 'none'));
        this.tabs[this.index].style.display = 'block';
    }
}
__decorate([
    property(),
    __metadata("design:type", Array)
], LithiumTabs.prototype, "tabs", void 0);
registerElementSafely('li-tab', LithiumTab);
registerElementSafely('li-tabs', LithiumTabs);

export { LithiumTabs };
//# sourceMappingURL=lithiumjs-tabs.js.map
