import { __makeTemplateObject, __extends, __decorate, __metadata } from 'tslib';
import { css, html, property, LitElement } from 'lit-element';
import '@a11y/focus-trap';
import { registerElementSafely } from 'lithiumjs/common';

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/** @type {?} */
var styles = css(templateObject_1 || (templateObject_1 = __makeTemplateObject(["\n  .li-modal-wrapper {\n    position: absolute;\n    top: 0;\n    left: 0;\n    right: 0;\n    bottom: 0;\n    z-index: 300;\n  }\n\n  .li-modal {\n    border: 1px solid #ccc;\n    padding: 12px;\n    background-color: #fff;\n    color: #2d2d2d;\n    width: 500px;\n    max-width: 100%;\n    margin: 24px auto;\n    position: relative;\n    z-index: 302;\n  }\n\n  .li-modal-close-btn {\n    position: absolute;\n    text-align: center;\n    width: auto;\n    height: auto;\n    padding: 12px;\n    font-size: 24px;\n    top: 0;\n    right: 0;\n    line-height: 14px;\n    border: 0;\n    background: transparent;\n    cursor: pointer;\n  }\n\n  .li-modal-backdrop {\n    background-color: rgba(0, 0, 0, 0.5);\n    position: fixed;\n    top: 0;\n    bottom: 0;\n    right: 0;\n    left: 0;\n    z-index: 301;\n  }\n"], ["\n  .li-modal-wrapper {\n    position: absolute;\n    top: 0;\n    left: 0;\n    right: 0;\n    bottom: 0;\n    z-index: 300;\n  }\n\n  .li-modal {\n    border: 1px solid #ccc;\n    padding: 12px;\n    background-color: #fff;\n    color: #2d2d2d;\n    width: 500px;\n    max-width: 100%;\n    margin: 24px auto;\n    position: relative;\n    z-index: 302;\n  }\n\n  .li-modal-close-btn {\n    position: absolute;\n    text-align: center;\n    width: auto;\n    height: auto;\n    padding: 12px;\n    font-size: 24px;\n    top: 0;\n    right: 0;\n    line-height: 14px;\n    border: 0;\n    background: transparent;\n    cursor: pointer;\n  }\n\n  .li-modal-backdrop {\n    background-color: rgba(0, 0, 0, 0.5);\n    position: fixed;\n    top: 0;\n    bottom: 0;\n    right: 0;\n    left: 0;\n    z-index: 301;\n  }\n"])));
var templateObject_1;

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
// @dynamic
var LithiumModal = /** @class */ (function (_super) {
    __extends(LithiumModal, _super);
    function LithiumModal() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.open = false;
        _this.backdropClosable = true;
        return _this;
    }
    Object.defineProperty(LithiumModal, "styles", {
        get: /**
         * @return {?}
         */
        function () {
            return styles;
        },
        enumerable: true,
        configurable: true
    });
    /**
     * @return {?}
     */
    LithiumModal.prototype.render = /**
     * @return {?}
     */
    function () {
        var _this = this;
        return html(templateObject_2 || (templateObject_2 = __makeTemplateObject(["\n      ", "\n    "], ["\n      ",
            "\n    "])), this.open
            ? html(templateObject_1$1 || (templateObject_1$1 = __makeTemplateObject(["\n          <div class=\"li-modal-wrapper\">\n            <div class=\"li-modal\" role=\"dialog\">\n              <focus-trap>\n                <div class=\"li-modal-header\">\n                  <slot name=\"header\"></slot>\n                  <button @click=\"", "\" type=\"button\" aria-label=\"closed\" class=\"li-modal-close-btn\">&times;</button>\n                </div>\n                <div class=\"li-modal-content\">\n                  <slot></slot>\n                </div>\n                <div class=\"li-modal-footer\">\n                  <slot name=\"footer\"></slot>\n                </div>\n              </focus-trap>\n            </div>\n            <div @click=\"", "\" class=\"li-modal-backdrop\"></div>\n          </div>\n          "], ["\n          <div class=\"li-modal-wrapper\">\n            <div class=\"li-modal\" role=\"dialog\">\n              <focus-trap>\n                <div class=\"li-modal-header\">\n                  <slot name=\"header\"></slot>\n                  <button @click=\"", "\" type=\"button\" aria-label=\"closed\" class=\"li-modal-close-btn\">&times;</button>\n                </div>\n                <div class=\"li-modal-content\">\n                  <slot></slot>\n                </div>\n                <div class=\"li-modal-footer\">\n                  <slot name=\"footer\"></slot>\n                </div>\n              </focus-trap>\n            </div>\n            <div @click=\"", "\" class=\"li-modal-backdrop\"></div>\n          </div>\n          "])), (/**
             * @return {?}
             */
            function () { return _this.close(); }), (/**
             * @return {?}
             */
            function () { return _this.backdropClose(); })) : '');
    };
    /**
     * @param {?} changedProperties
     * @return {?}
     */
    LithiumModal.prototype.updated = /**
     * @param {?} changedProperties
     * @return {?}
     */
    function (changedProperties) {
        if (this.open && this.open !== changedProperties.get('open')) ;
    };
    /**
     * @return {?}
     */
    LithiumModal.prototype.close = /**
     * @return {?}
     */
    function () {
        this.open = !this.open;
        this.dispatchEvent(new CustomEvent('openChange', { detail: this.open }));
    };
    /**
     * @return {?}
     */
    LithiumModal.prototype.backdropClose = /**
     * @return {?}
     */
    function () {
        if (this.backdropClosable) {
            this.close();
        }
    };
    __decorate([
        property({ type: Boolean }),
        __metadata("design:type", Object)
    ], LithiumModal.prototype, "open", void 0);
    __decorate([
        property({ type: Boolean }),
        __metadata("design:type", Object)
    ], LithiumModal.prototype, "backdropClosable", void 0);
    return LithiumModal;
}(LitElement));
registerElementSafely('li-modal', LithiumModal);
var templateObject_1$1, templateObject_2;

export { LithiumModal };
//# sourceMappingURL=lithiumjs-modal.js.map
